]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- kill adapter integration, use ./adapter to adapterize
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
cd445739
AM
1#!/bin/sh
2# -----------
3# $Id$
4# Exit codes:
2a5f078d 5# 0 - succesful
6# 1 - help displayed
7# 2 - no spec file name in cmdl parameters
8# 3 - spec file not stored in repo
9# 4 - some source, patch or icon files not stored in repo
10# 5 - package build failed
11# 6 - spec file with errors
12# 7 - wrong source in /etc/poldek.conf
13# 8 - Failed installing buildrequirements and subrequirements
14# 9 - Requested tag already exist
15# 10 - Refused to build fractional release
16# 100 - Unknown error (should not happen)
cd445739
AM
17
18# Notes (todo):
f7b91886 19# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
cd445739 20# - when Icon: field is present, -5 and -a5 doesn't work
f3ada241 21# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
931a4acf 22
4003ad8c 23VERSION="\
c9acaed9 24Build package utility from PLD Linux CVS repository
7304d35c 25V 0.13 (C) 1999-2005 Free Penguins".
d6a77ddb 26PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 27
cd445739 28COMMAND="build"
64ea5308 29TARGET=""
cd445739 30
bde1c404 31SPECFILE=""
d287305c 32BE_VERBOSE=""
4003ad8c 33QUIET=""
cd445739
AM
34CLEAN=""
35DEBUG=""
36NOURLS=""
37NOCVS=""
38NOCVSSPEC=""
39NODIST=""
40UPDATE=""
41UPDATE5=""
42ADD5=""
43NO5=""
44ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 45CVSROOT=""
cd445739
AM
46
47# It can be used i.e. in log file naming.
48# See LOGFILE example.
49DATE=`date +%Y-%m-%d_%H-%M-%S`
50
51# Example: LOGFILE='../log.$PACKAGE_NAME'
52# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
53# Yes, you can use variable name! Note _single_ quotes!
54LOGFILE=''
55
56LOGDIR=""
57LOGDIROK=""
58LOGDIRFAIL=""
59LASTLOG_FILE=""
60
61CHMOD="no"
62CHMOD_MODE="0444"
63RPMOPTS=""
64BCOND=""
65GROUP_BCONDS="no"
947025e5 66CVSIGNORE_DF="no"
d287305c 67
68PATCHES=""
69SOURCES=""
cd445739 70ICONS=""
d287305c 71PACKAGE_RELEASE=""
72PACKAGE_VERSION=""
73PACKAGE_NAME=""
cd445739
AM
74PROTOCOL="ftp"
75WGET_RETRIES=${MAX_WGET_RETRIES:-0}
76CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
77
78CVSTAG=""
79RES_FILE=""
80
81CVS_SERVER="cvs.pld-linux.org"
82DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 83ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 84
36d03934 85DEF_NICE_LEVEL=19
cd445739
AM
86
87FAIL_IF_NO_SOURCES="yes"
88
ab4a2b6e
ER
89if [ -x /usr/bin/rpm-getdeps ]; then
90 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
91else
92 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
93fi
94
cd445739
AM
95# Here we load saved user environment used to
96# predefine options set above, or passed to builder
97# in command line.
98# This one reads global system environment settings:
99if [ -f ~/etc/builderrc ]; then
100 . ~/etc/builderrc
101fi
102# And this one cascades settings using user personal
103# builder settings.
104# Example of ~/.builderrc:
105#
106#UPDATE_POLDEK_INDEXES="yes"
107#FETCH_BUILD_REQUIRES="yes"
108#REMOVE_BUILD_REQUIRES="force"
109#GROUP_BCONDS="yes"
110#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
111#
a83e5405 112SU_SUDO=""
cd445739
AM
113if [ -n "$HOME_ETC" ]; then
114 USER_CFG="$HOME_ETC/.builderrc"
115else
116 USER_CFG=~/.builderrc
117fi
118
119[ -f "$USER_CFG" ] && . "$USER_CFG"
120
06f3864d
AM
121wget --help 2>&1 | grep -q ' \-\-no-check\-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
122
ca2e6c31 123if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
124 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
125 GETURI2="$GETURI"
126 OUTFILEOPT="-O"
ca2e6c31 127elif [ -n "$USE_AXEL" ]; then
cede92b3 128 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
129 GETURI2="$GETURI"
130 OUTFILEOPT="-o"
ca2e6c31 131else
7e365483
KK
132 wget --help 2>&1 | grep -q ' \-\-inet ' && WGET_OPTS="$WGET_OPTS --inet"
133 wget --help 2>&1 | grep -q ' \-\-retry\-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
6f9a5d76 134
7e365483
KK
135 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
136 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
137 OUTFILEOPT="-O"
2bc5451f 138fi
11468b23 139
11468b23
AM
140GETLOCAL="cp -a"
141
142if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
143 RPM="rpm"
144 RPMBUILD="rpm"
145else
146 RPM="rpm"
147 RPMBUILD="rpmbuild"
148fi
149
150POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
a83e5405 151POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 152
cd445739
AM
153run_poldek()
154{
155 RES_FILE=~/tmp/poldek-exit-status.$RANDOM
156 if [ -n "$LOGFILE" ]; then
157 LOG=`eval echo $LOGFILE`
158 if [ -n "$LASTLOG_FILE" ]; then
159 echo "LASTLOG=$LOG" > $LASTLOG_FILE
160 fi
040282bb 161 (nice -n ${DEF_NICE_LEVEL} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
162 return $exit_pldk
163 else
164 (nice -n ${DEF_NICE_LEVEL} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
165 return `cat ${RES_FILE}`
166 rm -rf ${RES_FILE}
167 fi
168}
169
cd445739
AM
170#---------------------------------------------
171# functions
da946cd6 172
5a491465 173usage()
174{
cd445739
AM
175 if [ -n "$DEBUG" ]; then set -xv; fi
176 echo "\
177Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
81f85806 178
cd445739
AM
179[-bb|--build-binary] [-bs|--build-source] [-u|--try-upgrade]
180[{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>] [-g|--get]
181[-h|--help] [--http] [{-l,--logtofile} <logfile>] [-m|--mr-proper]
182[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T--tag <cvstag>]
183[-Tvs|--tag-version-stable] [-Tvn|--tag-version-nest]
184[-Ts|--tag-stable] [-Tn|--tag-nest] [-Tv|--tag-version]
185[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
dfe2cb9a 186[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--show-bconds]
cd445739 187[--with/--without <feature>] [--define <macro> <value>] <package>[.spec]
2a5f078d 188
cd445739
AM
189-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
190-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
191-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
192-D, --debug - enable builder script debugging mode,
193-debug - produce rpm debug package (same as --opts -debug)
cd445739
AM
194-V, --version - output builder version
195-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
196-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
197 from <package>.spec,
198-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
199 only package from <package>.spec,
200-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
201 them into src.rpm,
202-bp, --build-prep - execute the %prep phase of <package>.spec,
203-B, --branch - add branch
204-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
205 SPECS and \$RPM_BUILD_ROOT),
2a5f078d 206-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
207 - setup \$CVSROOT,
208--define <macro> <value>
209 - define a macro <macro> with value <value>,
210--nodeps - rpm won't check any dependences
211-g, --get - get <package>.spec and all related files from CVS repo
212 or HTTP/FTP,
213-h, --help - this message,
214--http - use http instead of ftp,
215-l <logfile>, --logtofile <logfile>
216 - log all to file,
217-m, --mr-proper - only remove all files related to spec file and all work
218 resources,
219-nc, --no-cvs - don't download sources from CVS, if source URL is given,
220-ncs, --no-cvs-specs
221 - don't check specs in CVS
222-nd, --no-distfiles - don't download from distfiles
223-nm, --no-mirrors - don't download from mirror, if source URL is given,
224-nu, --no-urls - don't try to download from FTP/HTTP location,
225-ns, --no-srcs - don't download Sources
226-ns0, --no-source0 - don't download Source0
227-nn, --no-net - don't download anything from the net
228--opts <rpm opts> - additional options for rpm
229-q, --quiet - be quiet,
230--date yyyy-mm-dd - build package using resources from specified CVS date,
231-r <cvstag>, --cvstag <cvstag>
232 - build package using resources from specified CVS tag,
233-R, --fetch-build-requires
234 - fetch what is BuildRequired,
235-RB, --remove-build-requires
236 - remove all you fetched with -R or --fetch-build-requires
237 remember, this option requires confirmation,
238-FRB, --force-remove-build-requires
239 - remove all you fetched with -R or --fetch-build-requires
240 remember, this option works without confirmation,
a7eefc54 241-sf, --source-files - list sources - bare filenames (intended for offline
242 operations; does not work when Icon field is present
243 but icon file is absent),
244-sp, --source-paths - list sources - filenames with full local paths (intended for
245 offline operations; does not work when Icon field is present
246 but icon file is absent),
cd445739
AM
247-T <cvstag> , --tag <cvstag>
248 - add cvs tag <cvstag> for files,
249-Tvs, --tag-version-stable
094bd95b 250 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739 251-Tvn, --tag-version-nest
1691a37b 252 - add cvs tags NEST and NAME-VERSION-RELEASE for files,
cd445739
AM
253-Ts, --tag-stable
254 - add cvs tag STABLE for files,
255-Tn, --tag-nest
256 - add cvs tag NEST for files,
257-Tv, --tag-version
1691a37b 258 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
259-Tp, --tag-prefix <prefix>
260 - add <prefix> to NAME-VERSION-RELEASE tags,
261-tt, --test-tag <prefix>
262 - fail if tag is already present,
50321881
JK
263-ir, --integer-release-only
264 - allow only integer and snapshot releases
cd445739
AM
265-v, --verbose - be verbose,
266-u, --try-upgrade - check version, and try to upgrade package
267-un, --try-upgrade-with-float-version
268 - as above, but allow float version
deccc50e 269-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
270-Upi, --update-poldek-indexes
271 - refresh or make poldek package index files.
c890b916 272-np, --nopatch <patchnumber>
bed98670 273 - don't apply <patchnumber>
dfe2cb9a
MK
274--show-bconds - show available conditional builds, which can be used
275 - with --with and/or --without switches.
cd445739
AM
276--with/--without <feature>
277 - conditional build package depending on %_with_<feature>/
278 %_without_<feature> macro switch. You may now use
279 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
280 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 281--target <platform>, --target=<platform>
64ea5308 282 - build for platform <platform>.
5a491465 283"
284}
285
c890b916 286update_shell_title() {
a0d6396b 287 [ -t 1 ] || return
2e5be021 288 local msg="builder[$SPECFILE] $*"
c890b916
ER
289 case "$TERM" in
290 cygwin|xterm*)
2e5be021 291 echo -ne "\033]1;$msg\007\033]2;$msg\007"
c890b916
ER
292 ;;
293 screen*)
2e5be021 294 echo -ne "\033]0;$msg\007"
c890b916
ER
295 ;;
296 esac
297}
298
7e40520f
ER
299# set TARGET from BuildArch: from SPECFILE
300set_spec_target() {
301 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
302 tmp=$(awk '/^BuildArch:/ { print $NF}' $SPECFILE)
303 if [ "$tmp" ]; then
304 TARGET="$tmp"
305 case "$RPMBUILD" in
306 "rpmbuild")
307 TARGET_SWITCH="--target $TARGET" ;;
308 "rpm")
309 TARGET_SWITCH="--target=$TARGET" ;;
310 esac
311 fi
312 fi
313}
314
cd445739 315cache_rpm_dump () {
b2aeec7d
AM
316 if [ -n "$DEBUG" ]; then
317 set -x;
318 set -v;
319 fi
7e40520f 320
cd445739
AM
321rpm_dump_cache=`
322 case "$RPMBUILD" in
323 rpm )
2a5f078d 324 rpm -bp --nodeps --define 'prep %dump' $BCOND $TARGET_SWITCH $SPECFILE 2>&1
cd445739
AM
325 ;;
326 rpmbuild )
2f810e46 327 rpmbuild --nodigest --nosignature --define 'prep %dump' $BCOND $TARGET_SWITCH $SPECFILE 2>&1
cd445739
AM
328 ;;
329 esac`
330}
331
332rpm_dump () {
333 if [ -z "$rpm_dump_cache" ] ; then
334 echo "internal error: cache_rpm_dump not called!" 1>&2
335 fi
336 echo "$rpm_dump_cache"
337}
338
59398507 339parse_spec()
340{
2e5be021 341 update_shell_title "parse_spec"
cd445739
AM
342 if [ -n "$DEBUG" ]; then
343 set -x;
344 set -v;
345 fi
b2975fc3 346
cd445739 347 cd $SPECS_DIR
4ca52257 348
cd445739 349 cache_rpm_dump
00fcec7e 350
cd445739
AM
351 if [ "$NOSRCS" != "yes" ]; then
352 SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
353 fi
354 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
355 FAIL_IF_NO_SOURCES="no"
356 fi
357
358 PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
359 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
360 PACKAGE_NAME="`$RPM -q --qf '%{NAME}\n' --specfile ${SPECFILE} 2> /dev/null | head -n 1`"
361 PACKAGE_VERSION="`$RPM -q --qf '%{VERSION}\n' --specfile ${SPECFILE} 2> /dev/null| head -n 1`"
362 PACKAGE_RELEASE="`$RPM -q --qf '%{RELEASE}\n' --specfile ${SPECFILE} 2> /dev/null | head -n 1`"
363
341603cf 364# These variables may be unset after first cache_rpm_dump call
365# (because of not-yet-retrieved icon file)
366#
367# if [ -z "$PACKAGE_NAME" -o -z "$PACKAGE_VERSION" -o -z "$PACKAGE_RELEASE" ]; then
368# Exit_error err_no_package_data;
369# fi
78eab2a1 370
cd445739
AM
371 if [ -n "$BE_VERBOSE" ]; then
372 echo "- Sources : `nourl $SOURCES`"
373 if [ -n "$PATCHES" ]; then
374 echo "- Patches : `nourl $PATCHES`"
375 else
376 echo "- Patches : *no patches needed*"
377 fi
378 if [ -n "$ICONS" ]; then
379 echo "- Icon : `nourl $ICONS`"
380 else
381 echo "- Icon : *no package icon*"
382 fi
383 echo "- Name : $PACKAGE_NAME"
384 echo "- Version : $PACKAGE_VERSION"
385 echo "- Release : $PACKAGE_RELEASE"
386 fi
387}
388
389Exit_error()
390{
391 if [ -n "$DEBUG" ]; then
392 set -x;
393 set -v;
394 fi
395
396 cd "$__PWD"
397
398 case "$1" in
399 "err_no_spec_in_cmdl" )
400 remove_build_requires
401 echo "ERROR: spec file name not specified.";
402 exit 2 ;;
403 "err_no_spec_in_repo" )
404 remove_build_requires
405 echo "Error: spec file not stored in CVS repo.";
406 exit 3 ;;
407 "err_no_source_in_repo" )
408 remove_build_requires
409 echo "Error: some source, patch or icon files not stored in CVS repo. ($2)";
410 exit 4 ;;
411 "err_build_fail" )
412 remove_build_requires
413 echo "Error: package build failed. (${2:-no more info})";
414 exit 5 ;;
78eab2a1
AM
415 "err_no_package_data" )
416 remove_build_requires
417 echo "Error: couldn't get out package name/version/release from spec file."
418 exit 6 ;;
50321881
JK
419 "err_tag_exists" )
420 remove_build_requires
421 echo "Tag ${2} already exists (spec release: ${3}).";
422 exit 9 ;;
423 "err_fract_rel" )
424 remove_build_requires
425 echo "Release ${2} not integer and not a snapshot.";
426 exit 10 ;;
fb96e0b5
AM
427 "err_branch_exists" )
428 remove_build_requires
429 echo "Tree branch already exists (${2}).";
430 exit 11 ;;
50321881 431
cd445739 432 esac
50321881 433 echo "Unknown error."
2a5f078d 434 exit 100
cd445739
AM
435}
436
437init_builder()
438{
439 if [ -n "$DEBUG" ]; then
440 set -x;
441 set -v;
0dd6320d 442 fi
cd445739
AM
443
444 SOURCE_DIR="`$RPM --eval '%{_sourcedir}'`"
445 SPECS_DIR="`$RPM --eval '%{_specdir}'`"
446
447 __PWD="`pwd`"
00fcec7e 448}
449
d6a77ddb 450get_spec()
1471f6d6 451{
c890b916 452
2e5be021 453 update_shell_title "get_spec"
c890b916 454
cd445739
AM
455 if [ -n "$DEBUG" ]; then
456 set -x;
457 set -v;
458 fi
459
460 cd "$SPECS_DIR"
461 if [ \! -f "$SPECFILE" ]; then
462 SPECFILE="`basename $SPECFILE .spec`.spec";
463 fi
464 if [ "$NOCVSSPEC" != "yes" ]; then
465 OPTIONS="up "
466
467 if [ -n "$CVSROOT" ]; then
468 OPTIONS="-d $CVSROOT $OPTIONS"
469 else
470 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
471 echo "warning: No cvs access defined - using local .spec file"
472 NOCVSSPEC="yes"
473 fi
474 fi
475
476 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
477 OPTIONS="$OPTIONS -A"
478 else
479 if [ -n "$CVSDATE" ]; then
480 OPTIONS="$OPTIONS -D $CVSDATE"
481 fi
482 if [ -n "$CVSTAG" ]; then
483 OPTIONS="$OPTIONS -r $CVSTAG"
484 fi
485 fi
486
487 result=1
488 retries_counter=0
489 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]
490 do
491 retries_counter=$(( $retries_counter + 1 ))
492 output=$(LC_ALL=C cvs $OPTIONS $SPECFILE 2>&1)
493 result=$?
494 [ -n "$output" ] && echo "$output"
495 if [ "$result" -ne "0" ]; then
496 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$retries_counter" -le "$CVS_RETRIES" ]; then
497 echo "Trying again [$SPECFILE]... ($retries_counter)"
498 sleep 2
499 continue
500 fi
501 Exit_error err_no_spec_in_repo;
502 fi
503 done
504 fi
505 if [ ! -f "$SPECFILE" ]; then
506 Exit_error err_no_spec_in_repo;
507 fi
508
509 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
510 chmod $CHMOD_MODE $SPECFILE
511 fi
512 unset OPTIONS
a7eefc54 513 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
7e40520f
ER
514
515 set_spec_target
cd445739
AM
516}
517
518find_mirror()
519{
520 cd "$SPECS_DIR"
521 url="$1"
522 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
523 cvs update mirrors >&2
524 fi
525
526 IFS="|"
527 while read origin mirror name rest
528 do
529 ol=`echo -n "$origin"|wc -c`
530 prefix="`echo -n "$url" | head -c $ol`"
531 if [ "$prefix" = "$origin" ] ; then
532 suffix="`echo "$url"|cut -b $ol-`"
533 echo -n "$mirror$suffix"
534 return 0
535 fi
536 done < mirrors
537 echo "$url"
538}
539
540src_no ()
541{
542 cd $SPECS_DIR
543 rpm_dump | \
544 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
545 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
546 head -n 1 | xargs
1471f6d6 547}
548
cd445739 549src_md5 ()
8ba5cdda 550{
cd445739
AM
551 [ X"$NO5" = X"yes" ] && return
552 no=$(src_no "$1")
553 [ -z "$no" ] && return
554 cd $SPECS_DIR
47a8df12 555 spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
cd445739
AM
556 if [ -z "$spec_rev" ]; then
557 spec_rev="$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
558 fi
559 spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
560 md5=$(grep -s -v '^#' additional-md5sums | \
561 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
562 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
563 grep -E '^[0-9a-f]{32}$')
564 if [ X"$md5" = X"" ] ; then
6203ea52
AG
565 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
566 if [ ! -z "$source_md5" ] ; then
7e365483 567 echo $source_md5;
6203ea52 568 else
7e365483
KK
569 # we have empty SourceX-md5, but it is still possible
570 # that we have NoSourceX-md5 AND NoSource: X
571 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
572 if [ ! -z "$nosource_md5" -a ! X"`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" = X"" ] ; then
573 echo $nosource_md5;
574 fi;
6203ea52 575 fi;
cd445739
AM
576 else
577 if [ $(echo "$md5" | wc -l) != 1 ] ; then
578 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
579 fi
580 echo "$md5" | tail -n 1
581 fi
582}
583
584distfiles_url ()
585{
1246dc2a 586 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
cd445739
AM
587}
588
589distfiles_attic_url ()
590{
1246dc2a 591 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
cd445739
AM
592}
593
594good_md5 ()
595{
596 md5=$(src_md5 "$1")
597 [ "$md5" = "" ] || \
598 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
599}
600
a4b50627
AF
601good_size ()
602{
deccc50e
AM
603 size="$(find $(nourl "$1") -printf "%s" 2>/dev/null)"
604 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
605}
606
947025e5 607cvsignore_df ()
608{
609 if [ "$CVSIGNORE_DF" != "yes" ]; then
610 return
611 fi
612 cvsignore=${SOURCE_DIR}/.cvsignore
613 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
614 echo "$1" >> $cvsignore
615 fi
616}
617
cd445739
AM
618get_files()
619{
620 GET_FILES="$@"
28fac57a 621 update_shell_title "get_files"
cd445739
AM
622
623 if [ -n "$DEBUG" ]; then
624 set -x;
625 set -v;
626 fi
627
628 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
629 cd "$SOURCE_DIR"
630
631 OPTIONS="up "
632 if [ -n "$CVSROOT" ]; then
633 OPTIONS="-d $CVSROOT $OPTIONS"
634 else
635 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
636 echo "warning: No cvs access defined for SOURCES"
637 NOCVS="yes"
638 fi
639 fi
640 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
641 OPTIONS="$OPTIONS -A"
642 else
643 if [ -n "$CVSDATE" ]; then
644 OPTIONS="$OPTIONS -D $CVSDATE"
645 fi
646 if [ -n "$CVSTAG" ]; then
647 OPTIONS="$OPTIONS -r $CVSTAG"
648 fi
649 fi
650 for i in $GET_FILES
651 do
652 if [ -n "$UPDATE5" ]; then
653 if [ -n "$ADD5" ]; then
654 [ `nourl $i` = "$i" ] && continue
655 grep -qiE '^#[ ]*Source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE && continue
656 else
657 grep -qiE '^#[ ]*Source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE || continue
658 fi
659 fi
660 FROM_DISTFILES=0
661 if [ ! -f `nourl $i` ] || [ $ALWAYS_CVSUP = "yes" ]; then
662 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
663 echo "Warning: no URL given for $i"
664 fi
665
666 if [ -n "$(src_md5 "$i")" ] && [ -z "$NODIST" ]; then
a4b50627 667 if good_md5 "$i" && good_size "$i"; then
deccc50e 668 echo "$(nourl "$i") having proper md5sum already exists"
cd445739
AM
669 continue
670 fi
671 target=$(nourl "$i")
672 url=$(distfiles_url "$i")
673 url_attic=$(distfiles_attic_url "$i")
674 FROM_DISTFILES=1
33da77c4 675 if [ "`echo $url | grep -E '^(\.|/)'`" ]; then
2e5be021 676 update_shell_title "get_files: $url"
cd445739
AM
677 ${GETLOCAL} $url $target
678 else
679 if [ -z "$NOMIRRORS" ]; then
680 url="`find_mirror "$url"`"
681 fi
2e5be021 682 update_shell_title "get_files: $url"
ca2e6c31 683 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 684 if [ "`echo $url | grep -E 'ftp://'`" ]; then
2e5be021 685 update_shell_title "get_files: $url"
ca2e6c31 686 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
687 fi
688 fi
689 if ! test -s "$target"; then
690 rm -f "$target"
691 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
2e5be021 692 update_shell_title "get_files: $url_attic"
cd445739
AM
693 ${GETLOCAL} $url_attic $target
694 else
695 if [ -z "$NOMIRRORS" ]; then
696 url_attic="`find_mirror "$url_attic"`"
697 fi
2e5be021 698 update_shell_title "get_files: $url_attic"
ca2e6c31 699 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 700 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
2e5be021 701 update_shell_title "get_files: $url_attic"
ca2e6c31 702 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
703 fi
704 fi
705 fi
947025e5 706 if test -s "$target"; then
707 cvsignore_df $target
708 else
cd445739
AM
709 rm -f "$target"
710 FROM_DISTFILES=0
711 fi
712 elif [ -z "$(src_md5 "$i")" -a "$NOCVS" != "yes" ]; then
713 # ( echo $i | grep -qvE '(ftp|http|https)://' ); -- if CVS should be used, but URLs preferred
714 result=1
715 retries_counter=0
716 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]
717 do
718 retries_counter=$(( $retries_counter + 1 ))
719 output=$(LC_ALL=C cvs $OPTIONS `nourl $i` 2>&1)
720 result=$?
721 [ -n "$output" ] && echo "$output"
722 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
723 echo "Trying again [`nourl $i`]... ($retries_counter)"
724 sleep 2
725 continue
726 else
727 break
728 fi
729 done
730 fi
731
33da77c4 732 if [ -z "$NOURLS" ] && [ ! -f "`nourl $i`" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739
AM
733 if [ -z "$NOMIRRORS" ]; then
734 im="`find_mirror "$i"`"
735 else
736 im="$i"
737 fi
2e5be021 738 update_shell_title "get_files: $im"
cd445739 739 ${GETURI} "$im" || \
33da77c4 740 if [ "`echo $im | grep -E 'ftp://'`" ]; then
2e5be021 741 update_shell_title "get_files: $im"
cd445739 742 ${GETURI2} "$im"
7e365483 743 fi
cd445739
AM
744 fi
745
746 fi
747 srcno=$(src_no $i)
748 if [ ! -f "`nourl $i`" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
749 Exit_error err_no_source_in_repo $i;
750 elif [ -n "$UPDATE5" ] && \
751 ( ( [ -n "$ADD5" ] && echo $i | grep -q -E 'ftp://|http://|https://' && \
752 [ -z "$(grep -E -i '^NoSource[ ]*:[ ]*'$i'([ ]|$)' $SPECS_DIR/$SPECFILE)" ] ) || \
753 grep -q -i -E '^#[ ]*source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE )
754 then
deccc50e 755 echo "Updating source-$srcno md5."
cd445739
AM
756 md5=$(md5sum `nourl $i` | cut -f1 -d' ')
757 perl -i -ne '
deccc50e
AM
758 print unless /^\s*#\s*Source'$srcno'-md5\s*:/i;
759 print "# Source'$srcno'-md5:\t'$md5'\n"
cd445739
AM
760 if /^Source'$srcno'\s*:\s+/;
761 ' \
762 $SPECS_DIR/$SPECFILE
763 fi
2a5f078d 764
a4b50627 765 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
766 :
767 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 768 # wrong md5 from distfiles: remove the file and try again
cd445739 769 # but only once ...
deccc50e 770 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
771 FROM_DISTFILES=2
772 rm -f $target
2e5be021 773 update_shell_title "get_files: $url"
ca2e6c31 774 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 775 if [ "`echo $url | grep -E 'ftp://'`" ]; then
2e5be021 776 update_shell_title "get_files: $url"
ca2e6c31 777 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
778 fi
779 if ! test -s "$target"; then
780 rm -f "$target"
2e5be021 781 update_shell_title "get_files: $url_attic"
ca2e6c31 782 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 783 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
2e5be021 784 update_shell_title "get_files: $url_attic"
ca2e6c31 785 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
786 fi
787 fi
788 test -s "$target" || rm -f "$target"
789 fi
790
a4b50627 791 if good_md5 "$i" && good_size "$i" ; then
cd445739
AM
792 :
793 else
deccc50e
AM
794 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
795 echo "or -5 to update md5 sums, if you're sure files are correct."
cd445739
AM
796 Exit_error err_no_source_in_repo $i
797 fi
798 done
799
800 if [ "$CHMOD" = "yes" ]; then
801 CHMOD_FILES="`nourl $GET_FILES`"
802 if [ -n "$CHMOD_FILES" ]; then
803 chmod $CHMOD_MODE $CHMOD_FILES
804 fi
805 fi
806 unset OPTIONS
807 fi
808}
809
810make_tagver() {
78eab2a1
AM
811
812 if [ -n "$DEBUG" ]; then
813 set -x;
814 set -v;
815 fi
2a5f078d 816
cd445739
AM
817 # Check whether first character of PACKAGE_NAME is legal for tag name
818 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
819 TAG_PREFIX=tag_
820 fi
821 TAGVER=$TAG_PREFIX$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
822 # Remove #kernel.version_release from TAGVER because tagging sources
823 # could occur with different kernel-headers than kernel-headers used at build time.
824 TAGVER=$(echo "$TAGVER" | sed -e 's/#.*//g')
825 echo -n "$TAGVER"
826}
827
828tag_files()
829{
830 TAG_FILES="$@"
831
832 if [ -n "$DEBUG" ]; then
833 set -x;
834 set -v;
835 fi
836
837 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
838 echo "Version: $PACKAGE_VERSION"
839 echo "Release: $PACKAGE_RELEASE"
840
841 TAGVER=`make_tagver`
842
843 if [ "$TAG_VERSION" = "yes" ]; then
844 echo "CVS tag: $TAGVER"
845 fi
846 if [ -n "$TAG" ]; then
847 echo "CVS tag: $TAG"
848 fi
849
850 OPTIONS="tag -F"
851 if [ -n "$CVSROOT" ]; then
852 OPTIONS="-d $CVSROOT $OPTIONS"
853 fi
854
855 cd "$SOURCE_DIR"
856 for i in $TAG_FILES
857 do
858 # don't tag files stored on distfiles
859 [ -n "`src_md5 $i`" ] && continue
860 if [ -f "`nourl $i`" ]; then
861 if [ "$TAG_VERSION" = "yes" ]; then
862 cvs $OPTIONS $TAGVER `nourl $i`
863 fi
864 if [ -n "$TAG" ]; then
865 cvs $OPTIONS $TAG `nourl $i`
866 fi
867 else
868 Exit_error err_no_source_in_repo $i
869 fi
870 done
871
872 cd "$SPECS_DIR"
873 if [ "$TAG_VERSION" = "yes" ]; then
874 cvs $OPTIONS $TAGVER $SPECFILE
875 fi
876 if [ -n "$TAG" ]; then
877 cvs $OPTIONS $TAG $SPECFILE
878 fi
879
880 unset OPTIONS
881 fi
882}
883
884branch_files()
885{
886 TAG=$1
887 echo "CVS branch tag: $TAG"
888 shift;
889
890 TAG_FILES="$@"
891
892 if [ -n "$DEBUG" ]; then
893 set -x;
894 set -v;
895 fi
896
897 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
898
899 OPTIONS="tag -b"
900 if [ -n "$CVSROOT" ]; then
901 OPTIONS="-d $CVSROOT $OPTIONS"
902 fi
903 cd "$SOURCE_DIR"
904 for i in $TAG_FILES
905 do
906 if [ -f `nourl $i` ]; then
907 cvs $OPTIONS $TAG `nourl $i`
908 else
909 Exit_error err_no_source_in_repo $i
910 fi
911 done
912 cd "$SPECS_DIR"
913 cvs $OPTIONS $TAG $SPECFILE
914
915 unset OPTIONS
916 fi
917}
918
919
920
59398507 921build_package()
922{
2e5be021 923 update_shell_title "build_package"
cd445739
AM
924 if [ -n "$DEBUG" ]; then
925 set -x;
926 set -v;
927 fi
5a491465 928
cd445739
AM
929 cd "$SPECS_DIR"
930
931 if [ -n "$TRY_UPGRADE" ]; then
2e5be021 932 update_shell_title "build_package: try_upgrade"
cd445739 933 if [ -n "$FLOAT_VERSION" ]; then
cc538c24 934 TNOTIFY=`./pldnotify.awk $SPECFILE -n` || exit 1
cd445739 935 else
cc538c24 936 TNOTIFY=`./pldnotify.awk $SPECFILE` || exit 1
cd445739
AM
937 fi
938
939 TNEWVER=`echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }'`
940
941 if [ -n "$TNEWVER" ]; then
942 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
943 echo "New version found, updating spec file to version " $TNEWVER
944 cp -f $SPECFILE $SPECFILE.bak
945 chmod +w $SPECFILE
946 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 947 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
cd445739 948 parse_spec;
7f347798 949 if [ -n "$ICONS" ]; then
950 get_files $ICONS;
951 parse_spec;
952 fi
f7b91886 953 NODIST="yes" UPDATE5="yes" get_files "$SOURCES $PATCHES";
cd445739
AM
954 unset TOLDVER TNEWVER TNOTIFY
955 fi
956 fi
957 cd "$SPECS_DIR"
2a5f078d 958
cd445739
AM
959 case "$COMMAND" in
960 build )
961 BUILD_SWITCH="-ba" ;;
962 build-binary )
963 BUILD_SWITCH="-bb" ;;
964 build-source )
965 BUILD_SWITCH="-bs --nodeps" ;;
966 build-prep )
967 BUILD_SWITCH="-bp --nodeps" ;;
968 esac
c890b916 969
2e5be021 970 update_shell_title "build_package: $COMMAND"
cd445739
AM
971 if [ -n "$LOGFILE" ]; then
972 LOG=`eval echo $LOGFILE`
973 if [ -d "$LOG" ]; then
974 echo "Log file $LOG is a directory."
975 echo "Parse error in the spec?"
976 Exit_error err_build_fail;
977 fi
978 if [ -n "$LASTLOG_FILE" ]; then
979 echo "LASTLOG=$LOG" > $LASTLOG_FILE
980 fi
981 RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
21bc1a97 982 (time eval nice -n ${DEF_NICE_LEVEL} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $TARGET_SWITCH $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
983 RETVAL=`cat $RES_FILE`
984 rm $RES_FILE
985 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
986 if [ "$RETVAL" -eq "0" ]; then
987 mv $LOG $LOGDIROK
988 else
989 mv $LOG $LOGDIRFAIL
990 fi
991 fi
8ba5cdda 992 else
8f96ab6c 993 eval nice -n ${DEF_NICE_LEVEL} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $TARGET_SWITCH $SPECFILE
cd445739 994 RETVAL=$?
8ba5cdda 995 fi
cd445739
AM
996 if [ "$RETVAL" -ne "0" ]; then
997 if [ -n "$TRY_UPGRADE" ]; then
998 echo "\n!!! Package with new version cannot be build automagically\n"
999 mv -f $SPECFILE.bak $SPECFILE
1000 fi
1001 Exit_error err_build_fail;
1002 fi
1003 unset BUILD_SWITCH
1004}
1005
1006nourl()
1007{
1008 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1009}
1010
cd445739
AM
1011install_required_packages()
1012{
1013 run_poldek -vi $1
1014 return $?
1015}
1016
1017set_bconds_values()
1018{
2e5be021 1019 update_shell_title "set_bconds_values"
c890b916 1020
cd445739
AM
1021 AVAIL_BCONDS_WITHOUT=""
1022 AVAIL_BCONDS_WITH=""
1023 if `grep -q ^%bcond ${SPECFILE}`; then
1024 BCOND_VERSION="NEW"
36d03934 1025 elif `egrep -q ^#\ *_with ${SPECFILE}`; then
cd445739
AM
1026 BCOND_VERSION="OLD"
1027 else
1028 BCOND_VERSION="NONE"
1029 fi
301cbfd4
ER
1030
1031 # expand bconds from ~/.bcondrc
1032 # The file structure is like gentoo's package.use:
1033 # ---
1034 # * -selinux
1035 # samba -mysql -pgsql
47a8df12 1036 # w32codec-installer license_agreement
301cbfd4
ER
1037 # php +mysqli
1038 # ---
c8a3e2ac 1039 if [ "${BCOND_VERSION}" != "NONE" ] && ( [ -f $HOME/.bcondrc ] || ( [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] ) ) ; then
301cbfd4
ER
1040 # This takes package name, first defined in spec.
1041 # so consider that when defining flags for package.
1042 PN=`$RPM -q --qf '%{NAME}\n' --specfile $SPECFILE | head -n 1`
3e1cbfe0 1043 SN=${SPECFILE%%\.spec}
301cbfd4
ER
1044 AVAIL=`$RPMBUILD --bcond $SPECFILE`
1045
c8a3e2ac
AG
1046 BCONDRC=$HOME/.bcondrc
1047 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && BCONDRC=$HOME_ETC/.bcondrc
1048
301cbfd4
ER
1049 while read pkg flags; do
1050 # ignore comments
1051 [[ "$pkg" == \#* ]] && continue
1052
1053 # any package or current package?
3e1cbfe0 1054 if [ "$pkg" = "*" ] || [ "$pkg" = "$PN" ] || [ "$pkg" = "$SN" ]; then
301cbfd4
ER
1055 for flag in $flags; do
1056 opt=${flag#[+-]}
1057
1058 # use only flags which are in this package.
1059 if [[ $AVAIL = *${opt}* ]]; then
3b5101f0
ER
1060 if [[ $flag = -* ]]; then
1061 BCOND="$BCOND --without $opt"
301cbfd4 1062 else
3b5101f0 1063 BCOND="$BCOND --with $opt"
301cbfd4
ER
1064 fi
1065 fi
1066 done
1067 fi
c8a3e2ac 1068 done < $BCONDRC
301cbfd4
ER
1069 fi
1070
cd445739
AM
1071 case "${BCOND_VERSION}" in
1072 NONE)
7e365483 1073 :
cd445739 1074 ;;
7e365483 1075 OLD)
cd445739
AM
1076 echo "Warning: This spec has old style bconds. Fix it || die."
1077 for opt in `$RPMBUILD --bcond $SPECFILE |grep ^_without_`
1078 do
1079 AVAIL_BCOND_WITHOUT=`echo $opt|sed -e "s/^_without_//g"`
1080 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1081 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1082 else
1083 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1084 fi
1085 done
2a5f078d 1086
cd445739
AM
1087 for opt in `$RPMBUILD --bcond $SPECFILE |grep ^_with_`
1088 do
1089 AVAIL_BCOND_WITH=`echo $opt|sed -e "s/^_with_//g"`
1090 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1091 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1092 else
1093 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1094 fi
1095 done
1096 ;;
1097 NEW)
1098 cond_type="" # with || without
1099 for opt in `$RPMBUILD --bcond $SPECFILE`
1100 do
1101 case "$opt" in
1102 _without)
1103 cond_type="without"
1104 ;;
1105 _with)
1106 cond_type="with"
1107 ;;
f8d24cee 1108 _without_*)
1109 AVAIL_BCOND_WITHOUT="`echo $opt | sed 's/^_without_//g'`"
1110 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1111 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1112 else
1113 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1114 fi
1115 ;;
1116 _with_*)
1117 AVAIL_BCOND_WITH="`echo $opt | sed 's/^_with_//g'`"
1118 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1119 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1120 else
1121 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1122 fi
1123 ;;
cd445739
AM
1124 *)
1125 case "$cond_type" in
1126 with)
1127 cond_type=''
1128 AVAIL_BCOND_WITH="$opt"
1129 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1130 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1131 else
1132 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1133 fi
7e365483 1134 ;;
cd445739
AM
1135 without)
1136 cond_type=''
1137 AVAIL_BCOND_WITHOUT="$opt"
1138 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1139 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1140 else
1141 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1142 fi
1143 ;;
1144 esac
1145 ;;
1146 esac
1147 done
1148 ;;
1149 esac
1150}
1151
1152run_sub_builder()
1153{
1154 package_name="${1}"
1155 echo -ne "Package installation failed:\t$package_name\n"
1156 #
1157